<?php
// ----------------------------------------------------------------------
// File: $Id: footer.php,v 1.10 2003/12/25 14:11:59 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * footer.php
 *
 * Diese Datei wird eingebunden, um die HTML-Ausgabe zu beenden.
 *
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.2
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage System
 * @category Display
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * Zugang prfen
 *
 * @ignore
 */
if (substr($_SERVER['SCRIPT_NAME'], strlen($_SERVER['SCRIPT_NAME']) - 9) == 'header.php')
    vkpLocation();

/**
 * footer
 *
 * Wird nach dem Laden dieser Datei auf 1 gesetzt.
 *
 * @var int
 * @deprecated
 */
$GLOBALS['footer'] = 1;

/**
 * footmsg
 *
 * Diese Funktion gibt die Fuzeilen aus.
 *
 * @see foot(), vkpGetFootMsg()
 * @author Hinrich Donner
 * @version 0.3
 * @since 5.5.1
 */
function footmsg()
{
    echo vkpGetFootMsg();
}

/**
 * vkpFootMsgMakros
 *
 * Ersetzt die Makros.
 *
 * @param string $message Der Text
 * @return string
 * @access private
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 */
function vkpFootMsgMakros($message)
{
    static $replace, $search;

    if (!isset($replace))
    {
        // Makros
        //
        $search = array("/(<vkp_page_creation_time>)/e",
                        "/(<vkp_year>)/e");

        // Ersetzer
        //
        $replace = array('vkpTimerMakroEllapsed()',
                         'date("Y")');
    }
    $result = preg_replace($search, $replace, $message);
    return $result;
}

/**
 * vkpGetFootMsg
 *
 * Erstellt die Fuzeile, sofern dieses erwnscht ist.
 *
 * @return string
 * @author Hinrich Donner
 * @version 0.2
 * @since 5.5.1
 */
function vkpGetFootMsg()
{
    $config =& vkpConfig::GetInstance();

    // Fuzeile
    //
    $result = "<div align=\"center\" id=\"center\"><span class=\"tiny\">\n"
        . ((empty($config->foot1) || !$config->footer_1_visible) ? '' : vkpFootMsgMakros($config->foot1) . "<br>\n")
        . ((empty($config->foot2) || !$config->footer_2_visible) ? '' : vkpFootMsgMakros($config->foot2) . "<br>\n")
        . ((empty($config->foot3) || !$config->footer_3_visible) ? '' : vkpFootMsgMakros($config->foot3) . "<br>\n")
        . ((empty($config->foot4) || !$config->footer_4_visible) ? '' : vkpFootMsgMakros($config->foot4) . "<br>\n")
        . "</span></div>\n";
    return $result;
}

/**
 * vkpTimerMakroEllapsed
 *
 * Diese Funktion liefert die bisher bentigte Zeit.
 *
 * @return string
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 */
function vkpTimerMakroEllapsed()
{
    global $__vkp_timer, $locale;

    setlocale(LC_NUMERIC, $locale);

    $result = sprintf(_PAGE_CREATION_TIME, $GLOBALS['__vkp_timer']->Ellapsed());
    return $result;
}

/**
 * foot
 *
 * Diese funktion gibt die Fuzeilen aus. Vorher wird die Funktion themefooter()
 * des aktuellen Themes aufgerufen. Zum Schluss wird der BODY- und HTML-Tag
 * geschlossen.
 *
 * @see head()
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.2
 * @since 5.5.1
 */
function foot()
{
    // Footer des Themes aufrufen
    //
    themefooter();

    // Konfiguration
    //
    $config =& vkpConfig::GetInstance();

    if ($config->sql_debug && vkpAdminLoggedIn())
    {
        global $__sql_queries;

        echo '<table width="100%" cellpadding="3" cellspacing="0" border="1">';
        foreach ($__sql_queries as $query)
        {
            echo '<tr><td><small>' . $query . '</small></td></tr>';
        }
        echo '<tr><td><small>' . count($__sql_queries) . ' Queries.</small></td></tr>'
            . "</table>\n";
    }

    echo "\n</body>\n"
        . "</html>\n";
}

/**
 * Dokument schlieen
 *
 * Automatischer Aufruf beim Einbinden dieser Datei.
 *
 * @ignore
 */
foot();

// $Log: footer.php,v $
// Revision 1.10  2003/12/25 14:11:59  hdonner
// - Fusszeilen einzeln schaltbar
//
// Revision 1.9  2003/12/11 16:35:07  hdonner
// - Fuzeile auch als String statt der Ausgabe
//
// Revision 1.8  2003/12/08 16:41:43  hdonner
// - Themes-Backcore angepasst
//
// Revision 1.7  2003/11/16 12:49:18  hdonner
// - $PHP_SELF in $_SERVER['PHP_SELF'] gendert
//
// Revision 1.6  2003/11/11 20:47:29  hdonner
// - DIV-Tags verwendet
//
// Revision 1.5  2003/11/10 20:19:59  hdonner
// - SQL-Queries im Debug-Mode nur f|r Admins sichtbar
//
// Revision 1.4  2003/11/10 15:54:44  hdonner
// - Ein weiteres Makro: <vkp_year>
//
// Revision 1.3  2003/11/10 13:10:44  hdonner
// - Zeitmessung fuer den Seitenaufbau als Makro in der Fusszeile
//
//
?>
