<?php
// ----------------------------------------------------------------------
// File: $Id: nukesystem.php,v 1.4 2003/12/06 19:01:40 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * nukesystem.php
 *
 * Diese Datei enthlt die Funktionen, die das System selbst bentigt,
 * deren Existenz aber fr Module und Themes unerheblich sind. Da diese
 * Funktionen nicht Bestandteil der API sind, knnen sie sich jederzeit
 * ndern.
 *
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage System
 * @category Datenmanagement
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * render_blocks
 *
 * Eine "Zwischenfunktion", die versucht, das Chaos bei dem Blocksystem
 * erfolglos in den Griff zu bekommen.
 *
 * @param string $side Die Position des Blocks (l, r, c, d)
 * @param string $blockfile Dateiname der PHP-Datei mit dem Code fr den Block
 * @param string $title Der Titel des Blocks
 * @param string $content Der Inhalt des Blocks
 * @param int $bid Die Datenbank-ID des Blocks
 * @param string $url Die URL der RDF-Resource
 * @author Hinrich Donner
 * @author Jens Ferner
 * @author F. Bruzi
 * @version 0.4
 * @since 5.5.1
 */
function render_blocks($side, $blockfile, $title, $content, $bid, $url)
{
    static $config;

    if (!isset($config))
        $config =& vkpConfig::GetInstance();

    // Das drfte nur selten den gewnschten Erfolg bringen...
    //
    if (eregi("who",$title) && ($config->jdcache==1) )
        return 0;

    if (empty($url))
    {
        if (empty($blockfile))
        {
            if (($side == 'c') || ($side == 'd'))
                themecenterbox($title, $content);
            else
                themesidebox($title, $content);
        }
        else
        {
            if (($side == 'c') || ($side == 'd'))
                blockfileinc($title, $blockfile, 1);
            else
                blockfileinc($title, $blockfile);
        }
    }
    else
    {
        if (($side == 'c') || ($side == 'd'))
            headlines($bid, 1);
        else
            headlines($bid);
    }
}

/**
 * online
 *
 * Aktualisiert die Daten fr die Online-Informationen.
 *
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.2
 * @since 5.5.1
 */
function online()
{
    $config =& vkpConfig::GetInstance();
    cookiedecode();
    $ip = $_SERVER['REMOTE_ADDR'];
    if (!vkpUserLoggedIn())
    {
        $username   = $ip;
        $guest      = 1;
    }
    else
    {
        $username   = vkpUserGetUname();
        $guest      = 0;
    }

    $ctime = time();
    $past = $ctime - 1800;
    sql_query("DELETE FROM `".$config->prefix."_session`
               WHERE `time`<'$past'");
    $result = sql_query("SELECT `time`
                         FROM `".$config->prefix."_session`
                         WHERE `username`='" . vkpVarPrepForStore($username) . "'");
    if ($row = sql_fetch_array($result))
        $sql = "UPDATE `".$config->prefix."_session`
                SET `username`='" . vkpVarPrepForStore($username) . "',
                    `time`='$ctime',
                    `host_addr`='" . vkpVarPrepForStore($ip) . "',
                    `guest`='$guest'
                WHERE `username`='" . vkpVarPrepForStore($username) . "'";
    else
        $sql = "INSERT INTO `".$config->prefix."_session`
                (`username`,
                 `time`,
                 `host_addr`,
                 `guest`)
                VALUES ('" . vkpVarPrepForStore($username) . "',
                        '$ctime',
                        '" . vkpVarPrepForStore($ip) . "',
                        '$guest')";
    sql_query($sql);
}

/**
 * blockfileinc
 *
 * Ld den Code eines Blocks und fhrt ihn aus.
 *
 * @author F. Bruzi
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 */
function blockfileinc($title, $blockfile, $side = 0)
{
    $blockfiletitle = $title;
    $blockfilename  = 'blocks/' . vkpVarPrepForOs($blockfile);

    if (!file_exists($blockfilename))
        $content = _BLOCKPROBLEM;
    else
    {
        $content = '';
        include $blockfilename;
    }

    if (empty($content))
        $content = _BLOCKPROBLEM2;

    if ($side == 1)
        themecenterbox($blockfiletitle, $content);
    else
        themesidebox($blockfiletitle, $content);
}

/**
 * ultramode
 *
 * Erstellt die Datei 'ultramode.txt'.
 *
 * @author F. Bruzi
 * @version 0.1
 * @since 5.5.1
 */
function ultramode()
{
    global $prefix, $dbi;
    $ultra = "ultramode.txt";
    $file = fopen("$ultra", "w");
    fwrite($file, "General purpose self-explanatory file with news headlines\n");
    $rfile=sql_query("select sid, aid, title, time, comments, topic from ".$prefix."_stories order by time DESC limit 0,10", $dbi);
    while(list($sid, $aid, $title, $time, $comments, $topic) = sql_fetch_row($rfile, $dbi)) {
    $rfile2=sql_query("select topictext, topicimage from ".$prefix."_topics where topicid=$topic", $dbi);
    list($topictext, $topicimage) = sql_fetch_row($rfile2, $dbi);
    $content = "%%\n$title\n/modules.php?name=News&file=article&sid=$sid\n$time\n$aid\n$topictext\n$comments\n$topicimage\n";
    fwrite($file, $content);
    }
    fclose($file);
}

/**
 * automated_news
 *
 * Diese Funktion publiziert die zeitgesteuerten News
 *
 * @author F. Bruzi
 * @version 0.1
 * @since 5.5.1
 */
function automated_news()
{
    global $prefix, $multilingual, $currentlang, $dbi;

    if ($multilingual == 1)
        /* the OR is needed to display stories who are posted to ALL languages */
        $querylang = "WHERE (`alanguage`='" . vkpVarPrepForStore($currentlang) . "' OR `alanguage`='')";
    else
        $querylang = "";

    $today = getdate();
    $day = $today['mday'];
    if ($day < 10) {
    $day = "0$day";
    }
    $month = $today['mon'];
    if ($month < 10) {
    $month = "0$month";
    }
    $year = $today['year'];
    $hour = $today['hours'];
    $min = $today['minutes'];
    $sec = "00";
    $result = sql_query("select anid, time from ".$prefix."_autonews $querylang", $dbi);
    while(list($anid, $time) = sql_fetch_row($result, $dbi)) {
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $date);
    if (($date[1] <= $year) AND ($date[2] <= $month) AND ($date[3] <= $day)) {
        if (($date[4] < $hour) AND ($date[5] >= $min) OR ($date[4] <= $hour) AND ($date[5] <= $min)) {
        $result2 = sql_query("select catid, aid, title, time, hometext, bodytext, topic, informant, notes, ihome, alanguage, acomm from ".$prefix."_autonews where anid='$anid'", $dbi);
        while(list($catid, $aid, $title, $a_time, $hometext, $bodytext, $topic, $author, $notes, $ihome, $alanguage, $acomm) = sql_fetch_row($result2, $dbi)) {
            $title = stripslashes(FixQuotes($title));
            $hometext = stripslashes(FixQuotes($hometext));
            $bodytext = stripslashes(FixQuotes($bodytext));
            $notes = stripslashes(FixQuotes($notes));
            sql_query("insert into ".$prefix."_stories values (NULL, '$catid', '$aid', '$title', '$a_time', '$hometext', '$bodytext', '0', '0', '$topic', '$author', '$notes', '$ihome', '$alanguage', '$acomm', '0', '0', '0', '0')", $dbi);
            sql_query("delete from ".$prefix."_autonews where anid='$anid'", $dbi);
        }
        }
    }
    }
}


// $Log: nukesystem.php,v $
// Revision 1.4  2003/12/06 19:01:40  hdonner
// - Kleine Fixes
//
// Revision 1.3  2003/12/05 21:49:37  hdonner
// - Umstellung bei dem Zugriff auf die Konfigurationsvariablen
//
// Revision 1.2  2003/11/20 21:11:37  hdonner
// - Vermeidung von Warnings unter E_ALL
//
// Revision 1.1  2003/11/12 19:16:43  hdonner
// - Trennung zwischen API und internen Funktionen
//
//
?>
