<?php
// ----------------------------------------------------------------------
// File: $Id: vkpadmin.php,v 1.1 2003/12/15 23:20:41 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * vkpadmin.php
 *
 * Diese Datei enthlt die Funktionen, die man zur API zhlt. Dabei
 * handelt es sich um Funktionen, die die Informationen des angemeldeten
 * Autors bzw. Administrators betreffen.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * vkpAdmin
 *
 * Das OOP-Interface einbinden.
 *
 * @ignore
 */
require_once VKP_INCLUDE_DIR . '/classes/vkpadmin.php';

/**
 * vkpAdminLoggedIn
 *
 * Diese Funktion prft, ob der angemeldete Benutzer als Administrator
 * angemeldet ist.
 *
 * @return bool TRUE oder FALSE
 * @since 5.5.1
 * @version 0.2
 * @author Hinrich Donner
 * @see vkpAdminHasFlag()
 */
function vkpAdminLoggedIn()
{
    static $result;

    if (isset($result))
        return $result;

    $admin  =& vkpAdmin::GetInstance();
    $result = $admin->logged_in;
    return $result;
}

/**
 * vkpAdminHasFlag
 *
 * Diese Funktion prft, ob der betreffende Benutzer als Administrator
 * angemeldet ist und ber das entsprechende Flag (Tabellenfelder
 * 'radnmin*' verfgt.  'radminsuper' stellt dabei alle Flags auf 1.
 *
 * @param string $flag Das gewnschte Flag
 * @return bool TRUE or FALSE
 * @since 5.5.1
 * @version 0.2
 * @author Hinrich Donner
 * @see vkpAdminLoggedIn()
 */
function vkpAdminHasFlag($flag)
{
    static $admin;

    if (!isset($admin))
        $admin =& vkpAdmin::GetInstance();

    return $admin->HasFlag($flag);

    // Wer nicht Administrator ist, hat sowieso keine Rechte...
    //
    if (!vkpAdminLoggedIn())
        return false;
}

/**
 * vkpAdminGetAid
 *
 * Liefert die AID des aktuellen Webmasters.
 *
 * @return string Die aid oder FALSE
 * @since 5.5.1
 * @version 0.2
 * @author Hinrich Donner
 * @see vkpAdminLoggedIn()
 */
function vkpAdminGetAid()
{
    static $result;

    if (isset($result))
        return $result;

    $admin  =& vkpAdmin::GetInstance();
    $result = $admin->GetId();
    return $result;
}

/**
 * vkpAdminGetLanguage
 *
 * Liefert die eingestellte Sprache des Administrators zurck.  Dabei
 * wird auch berprft, ob die Sprache berhaupt verfgbar ist.
 *
 * @return string Die Sprache oder einen Leerstring
 * @since 5.5.1
 * @version 0.2
 * @author Hinrich Donner
 * @see vkpAdminLoggedIn()
 */
function vkpAdminGetLanguage()
{
    static $result;

    if (isset($result))
        return $result;

    $admin  =& vkpAdmin::GetInstance();
    $result = $admin->GetLanguage();
    return $result;
}

// $Log: vkpadmin.php,v $
// Revision 1.1  2003/12/15 23:20:41  hdonner
// - Umstellung auf die Klasse
//
//
?>
