<?php
// ----------------------------------------------------------------------
// File: $Id: vkpmodules.php,v 1.1 2003/12/17 17:39:36 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * vkpmodules.php
 *
 * Diese Datei enthlt die Funktionen, die man zur API zhlt. Dabei
 * handelt es sich um Funktionen, die im Standard PHP-Nuke nicht
 * vorhanden sind.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API
 * @category Modulinformationen
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * OOP-Interface laden
 *
 * @ignore
 */
require_once VKP_INCLUDE_DIR . '/classes/vkpmodules.php';

/**
 * vkpModuleGetAll
 *
 * Gibt eine Referenz auf die Liste aller Module zurck.
 *
 * @return array
 * @see vkpModuleGet()
 * @author Hinrich Donner
 */
function vkpModuleGetAll()
{
    static $result;

    if (isset($result))
        return $result;

    $modules =& vkpModules::GetInstance();
    $result = $modules->GetAll();
    return $result;
}

/**
 * vkpModuleGetMain
 *
 * Liefert den Datensatz des Startmodules.
 *
 * @return vkpModule
 * @author Hinrich Donner
 * @author Hinrich Donner
 * @version 0.2
 * @since 5.5.1
 */
function &vkpModuleGetMain()
{
    static $result;

    if (isset($result))
        return $result;

    $modules    =& vkpModules::GetInstance();
    $result     =& $modules->GetMain();
    return $result;
}

/**
 * vkpModuleGet
 *
 * Liefert die Informationen eines Modules als Referenz zurck.
 *
 * @param string $modulename Der Name
 * @return vkpModule
 * @author Hinrich Donner
 * @version 0.2
 * @since 5.5.1
 */
function &vkpModuleGet($modulename)
{
    static $modules;

    if (!isset($modules))
        $modules    =& vkpModules::GetInstance();

    if (!empty($modulename) && isset($modules->$modulename))
        return $modules->$modulename;
    return null;
}

/**
 * vkpModuleIsActive
 *
 * Testet, ob das namentlich angegebene Modul aktiv ist.
 *
 * @param string $modulename Der Name
 * @return bool
 * @author Hinrich Donner
 * @version 0.2
 * @since 5.5.1
 */
function vkpModuleIsActive($modulename)
{
    static $modules;

    if (!isset($modules))
        $modules    =& vkpModules::GetInstance();

    if (!empty($modulename) && isset($modules->$modulename))
        return $modules->$modulename->active;
    return false;
}

// $Log: vkpmodules.php,v $
// Revision 1.1  2003/12/17 17:39:36  hdonner
// - Modulhandler in OOP
//
//
?>
