<?php 
// ----------------------------------------------------------------------
// File: $Id: vkpuser.php,v 1.2 2003/12/31 17:02:53 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------
/**
* vkpuser.php
* 
* Diese Datei enthlt die Funktionen, die man zur API zhlt. Dabei
* handelt es sich um Funktionen, die die Informationen des angemeldeten
* Benutzers betreffen.
* 
* @author Hinrich Donner 
* @version 0.1
* @since 5.5.1
* @package PHP-Nuke-VKP
* @subpackage API
* @link http://developer.berlios.de/projects/phpnukevkp/
*/

/**
* vkpUser
* 
* Das OOP-Interface einbinden.
* 
* @ignore 
*/
require_once VKP_INCLUDE_DIR . '/classes/vkpuser.php';

/**
* vkpUserLoggedIn
* 
* Diese Funktion prft, ob der augenblickliche Benutzer angemeldet ist.
* 
* @return bool TRUE oder FALSE
* @version 0.2
* @since 5.5.1
*/
function vkpUserLoggedIn()
{
    static $result;

    if (isset($result))
        return $result;

	$user =& vkpUser::GetInstance();
	$result = $user->LoggedIn();
	return $result;
} 

/**
* vkpUserGetUname
* 
* Liefert den Nicknamen des aktuellen Benutzers zurck.  Wenn der Benutzer nicht
* angemeldet ist, wird der Benutzername fr Gste zurckgegeben.
* 
* @return string 
* @version 0.2
* @since 5.5.1
* @author Hinrich Donner 
*/
function vkpUserGetUname()
{
    static $user;

    if (!isset($user))
        $user = vkpUser::GetInstance();

    return $user->GetUname();
} 

/**
* vkpUserGetUBlockOn
* 
* Liefert den Wert, ob der User-Block aktiviert ist.
* 
* @return bool 
* @version 0.2
* @since 5.5.1
* @author Hinrich Donner 
* @see vkpUserGetUBlock()
*/
function vkpUserGetUBlockOn()
{
    static $user;

    if (!isset($user))
        $user = vkpUser::GetInstance();

    return $user->GetUBlockOn();
} 

/**
* vkpUserGetUBlock
* 
* Liefert den User-Block.
* 
* @return string
* @version 0.1
* @since 5.5.1
* @author Hinrich Donner 
* @see vkpUserGetUBlockOn()
*/
function vkpUserGetUBlock()
{
    static $user;

    if (!isset($user))
        $user = vkpUser::GetInstance();

    return $user->GetUBlock();
} 

/**
* vkpUserGetAllData
* 
* Liefert alle vorhandenen Daten des aktuellen Benutzers zurck.
* 
* @return array 
* @version 0.2
* @since 5.5.1
* @author Hinrich Donner 
*/
function vkpUserGetAllData()
{
    static $result;

	if (isset($result))
		return $result;
	
	$user =& vkpUser::GetInstance();
	$result = $user->details;
	return $result;
} 

/**
* vkpUserVarGet
* 
* Liefert den Wert einer bestimmten Variablen des Benutezrs
* zurck.
* 
* @param string $name Der Name der Variablen
* @return mixed Der Wert oder NULL
* @see vkpUserGetAllData(), vkpUser, vkpDbTable::GetVar()
* @version 0.2
* @since 5.5.1
* @author Hinrich Donner 
*/
function vkpUserVarGet($name)
{
    static $user;

	if (!isset($user))
		$user =& vkpUser::GetInstance();
	
	if ($user->ExistsVar($name))
		return $user->GetVar($name);
    return null;
} 

// $Log: vkpuser.php,v $
// Revision 1.2  2003/12/31 17:02:53  hdonner
// - User: OOP-API
//
// Revision 1.1  2003/12/26 15:26:14  hdonner
// - Benutzerfunktionen ausgelagert
// - Klasse vkpUser begonnen
//
?>