<?php
// ----------------------------------------------------------------------
// File: $Id: mainfile.php,v 1.17.2.3 2004/01/18 14:24:49 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * mainfile.php
 *
 * Diese Datei ist die zentrale Include-Datei fr PHP-Nuke.
 *
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.3
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage System
 * @category Verschiedenes
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * Error Reporting
 *
 * Whrend der Entwicklung wird die hchste Warnstufe verwendet.
 *
 * @ignore
 */
//error_reporting(E_ALL);

import_request_variables('GPC');

/**
 * Basisverzeichnis
 *
 * Der absolute Verzeichnisname dieser Datei.
 */
define('VKP_BASE_DIR',      dirname(__FILE__));

/**
 * Include-Verzeichnis
 *
 * Der Pfad, wo die Include-Dateien liegen.
 */
define('VKP_INCLUDE_DIR',   VKP_BASE_DIR . '/includes');

/**
 * Timer starten
 *
 * Der Timer soll so frh wie mglich gestartet werden, um auch die
 * Zeit zu messen, die fr das Einbinden der anderen Dateien bentigt
 * wird.
 *
 * @ignore
 */
require_once VKP_INCLUDE_DIR . '/classes/pstimer.php';
$__vkp_timer =& new psTimer();
$__vkp_timer->Start();

/**
 * __vkp_modules_list
 *
 * Die Liste aller Module, die in der Datenbank gespeichert sind.
 *
 * @var array
 * @access private
 * @see is_active()
 */
$__vkp_modules_list = array();

require_once VKP_INCLUDE_DIR . '/nexus.php';            // PHP-Nuke-VKP API

// Konfiguration lesen und fr den Kompatibilittsmodus alle Werte als
// globale Variablen setzen.
//
$config =& vkpConfig::GetInstance();
$config->MakeCopyInGlobalScope();

require_once VKP_INCLUDE_DIR . '/nukesystem.php';       // PHP-Nuke Systemfunktionen
require_once VKP_INCLUDE_DIR . '/nukeapi.php';          // PHP-Nuke API

/************************************************************************/
/* PHP-NUKE: Advanced Content Management System                         */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi (fbc@mandrakesoft.com)         */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

# Header Aufbau: JPCache oder ob_gzhandler?
$phpver = phpversion();

// Admin und User-Cookie holen oder leere Variable initialisieren
//
if (vkpCookieExists('admin'))
    $admin = vkpCookieGet('admin');
else
    $admin = null;
if (vkpCookieExists('user'))
    $user = vkpCookieGet('user');
else
    $user = null;

if (($jdcache == 1) && !eregi("(user|account|admin)", $PHP_SELF))
    require 'jpcache.php';
elseif (extension_loaded("zlib"))
{
    // Kompression aktivieren
    //
    if (!headers_sent()
            && (isset($_SERVER["HTTP_ACCEPT_ENCODING"]))
            && preg_match("/(gzip|deflate)/i", $_SERVER["HTTP_ACCEPT_ENCODING"]))
    {
        ini_set('zlib.output_compression', 'On');
        ini_set('zlib.output_compression_level', 5);
    }
}

#Bses rausfiltern
if (!ini_get("register_globals"))
{
    $php_ver = phpversion();
    $php_ver = explode(".", $php_ver);
    $phpver = "$php_ver[0]$php_ver[1]";
    if ($phpver >= 41)
    {
        $_SERVER['PHP_SELF'] = $_SERVER['PHP_SELF'];
        import_request_variables('GPC');
    }
}

/**
 * Variablen global machen
 *
 * Alle GET- und POST-Werte global machen, damit die Module es
 * in gewohnter Manier vorfinden.
 */
$__arguments = array_keys(vkpVarAllFromInput());
foreach ($__arguments as $__argument_key)
    $GLOBALS[$__argument_key] = vkpVarCleanFromInput($__argument_key);

/**
 * Prfen, ob die Datei direkt aufgerufen wurde.
 *
 * @ignore
 */
if (substr($_SERVER['SCRIPT_NAME'], strlen($_SERVER['SCRIPT_NAME']) - 12, 12) == 'mainfile.php')
    vkpLocation();

$mainfile = 1;

/**
 * op
 *
 * Diese Variable wird vielfach im Skript bentigt, weshalb sie global
 * gemacht wird.
 *
 * @var string
 * @see vkpVarCleanFromInput()
 */
$op = vkpVarCleanFromInput('op');

/**
 * newlang
 *
 * Diese Variable zeigt an, dass eine neue Sprache geladen werden soll.
 * Manche seltsame Module bentigen diese Variable, so dass sie aaus
 * Grnden der Kompatibilitt implementiert ist.  Fr tatschliche Zugriffe
 * sollte die Klasse vkpLanguages benutzt werden.
 *
 * @var string
 * @see vkpLanguages
 */
$newlang = vkpVarCleanFromInput('newlang');

/**
 * currentlang
 *
 * Diese globale Variable wird von nahezu jedem Modul benutzt.  Sie enthlt
 * den Namen der aktuellen Sprache.  VKP-Module sollten jedoch auf die
 * Instanz der Klasse vkpLanguages zurckgreifen.
 *
 * @var string
 * @see vkpLanguages
 */
$languages      =& vkpLanguages::GetInstance();
$currentlang    = $languages->current;

/**
 * ThemeSel
 *
 * Diese Variable enthlt den Namen des aktuellen Themes.  Sie wird
 * im Grunde lediglich von der Datei header.php bentigt. Dennoch gibt
 * es einige Module, die auf diese Variable zugreifen. Aus Grnden der
 * Kompatibilitt wird sie hier initialisiert.
 *
 * @var string
 * @see vkpThemes
 */
$themes     =& vkpThemes::GetInstance();
$ThemeSel   = $themes->current;

/**
 * Referer protokollieren
 *
 * @ignore
 */
if (($config->httpref == 1) && array_key_exists('HTTP_REFERER', $_SERVER))
{
    require_once VKP_INCLUDE_DIR . '/classes/vkpreferer.php';
    $referer =& new vkpReferer();
    $referer->Add($_SERVER['HTTP_REFERER']);
    $referer->Shrink($config->httprefmax);
}

// $Log: mainfile.php,v $
// Revision 1.17.2.3  2004/01/18 14:24:49  hdonner
// - Fix: Warnung gzhandler
//
// Revision 1.17.2.2  2004/01/13 16:27:51  hdonner
// - Fix #1342
//
// Revision 1.17.2.1  2004/01/11 18:05:00  hdonner
// - Fix: Warnung bei Problemen mit dem gz-Handler
// - Einige ueberfluessige Konstrukte entfernt
//
// Revision 1.17  2004/01/10 11:27:18  hdonner
// - Request-Argumente global gemacht, mit Schutz
//
// Revision 1.16  2004/01/02 20:38:39  hdonner
// - Sprachsteuerung ueberarbeitet
//
// Revision 1.15  2003/12/25 14:12:47  hdonner
// - Pruefung auf aeltere PHP-Version entfernt. 4.3.x ist zwingend!
//
// Revision 1.14  2003/12/17 17:36:42  hdonner
// - Anpassung auf die Klassen
//
// Revision 1.13  2003/12/06 19:02:57  hdonner
// - Vorbereitung Dezember-Snap
//
// Revision 1.12  2003/12/05 21:50:47  hdonner
// - Konfiguration aus einem Objekt
//
// Revision 1.11  2003/12/01 17:11:07  hdonner
// - Admin!Einstellungen neu gegliedert
// - Einfache Html-Tools begonnen
//
// Revision 1.10  2003/11/26 15:05:59  hdonner
// - Session-API
//
// Revision 1.9  2003/11/20 21:13:07  hdonner
// - VKP-Kern ausgelagert
//
// Revision 1.8  2003/11/16 12:50:21  hdonner
// - Returnwert in vkpModuleGet berichtigt
// - Modulliste initialisiert
//
// Revision 1.7  2003/11/12 19:16:43  hdonner
// - Trennung zwischen API und internen Funktionen
//
// Revision 1.6  2003/11/11 20:48:37  hdonner
// - Modul-Informationen: Funktionen hinzugefuegt
//
// Revision 1.5  2003/11/10 20:21:06  hdonner
// - Cookie bei Sprache wird nur gesetzt, wenn notwendig
// - Eine Reihe von Funktionen aus TIS |bernommen:
//   vkpVar*, vkpCookie*, vkpGetBase*, vkpLocation
//
// Revision 1.4  2003/11/10 15:02:32  hdonner
// - is_active() optimiert
//
// Revision 1.3  2003/11/10 13:10:44  hdonner
// - Zeitmessung fuer den Seitenaufbau als Makro in der Fusszeile
//
// Revision 1.2  2003/11/10 09:17:44  hdonner
// - is_user() und is_admin() optimiert
//
//
?>
