<?php
// ----------------------------------------------------------------------
// File: $Id: index.php,v 1.4.2.1 2004/01/17 15:14:17 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * index.php.php
 *
 * Die Hauptdatei fr das Modul PMSGs.
 *
 * @author Hinrich Donner
 * @author Andreas Kunz
 * @version 0.2
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage Module
 * @category Topics
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * Modulnamen ermitteln.
 *
 * @ignore
 */
$module_name = basename(dirname(__FILE__));
get_lang($module_name);

/**
 * Rechte Blcke ausschalten
 *
 * @ignore
 */


/**
 * ShowPmsgsHeader
 *
 * Beginnt den Bildschirmaufbau.
 *
 * @version 0.1
 * @since 5.5.1
 * @author Hinrich Donner
 * @todo Konfigurierbarkeit der rechten Blcke
 */
function ShowPmsgsHeader($title)
{
    global $index, $pagetitle;

    $index      = 0;
    $pagetitle  .= ' - ' . $title;

    include 'header.php';

    title($title);
}

/**
 * ShowPmsgsFooter
 *
 * Beendet den Bildschirmaufbau.
 *
 * @version 0.1
 * @since 5.5.1
 * @author Hinrich Donner
 */
function ShowPmsgsFooter()
{
    include 'footer.php';
}

/**
 * ShowPMSGsNew
 *
 * Zeigt die neuen Messages an. Diese Funktion wird per Default aufgerufen.
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function ShowPMSGsNew()
{
    global $bgcolor3;

    $user   =& vkpUser::GetInstance();
    $config         =& vkpConfig::GetInstance();
    $module_name    =& $GLOBALS['module_name'];
    $image_file     = 'modules/' . vkpVarPrepForOs($module_name) . '/images/new.gif';
    $image_file2    = 'modules/' . vkpVarPrepForOs($module_name) . '/images/loeschen.gif';
    $sql            = "SELECT `pmsg_id`,
                              `pmsg_from`,
                              `pmsg_subject`,
                              `pmsg_date`
                       FROM " . $config->prefix . "_pmsg
                       WHERE `pmsg_to`='" . vkpVarPrepForStore($user->GetUname()) . "'
                             AND `pmsg_read`='0'
                             AND `pmsg_del_to`='0'
                       ORDER BY `pmsg_id` DESC";

    ShowPmsgsHeader(_PMSGSPAGETITLE);
    OpenTable();
    echo "<a href=\"modules.php?name=$module_name\"><b>[ "._PMSGSNEWMESSAGES." ]</b></a></td>\n"
        . "<td><div  align=\"center\">"
        . "<a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsRead\">[ " . _PMSGSARCHIV . " ]</a></div></td>\n"
        . "<td align=\"right\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsSend\">[ " . _PMSGSOUTGOINGPOST . " ]</a>";
    CloseTable();
    echo "<br>\n";

    OpenTable();
    echo "<table width=\"100%\" cellpadding=\"2\" cellspacing=\"0\" border=\"0\">"
        . "<tr bgcolor=\"$bgcolor3\">\n"
        . "<td><b>" . _PMSGSSENDER . "</b></td>\n"
        . "<td><b>" . _PMSGSSUBJECT . "</b></td>\n"
        . "<td><b>" . _PMSGSDATETIME . "</b></td>\n"
        . "<td><b>" . _PMSGSACTION . "</b></td></tr>\n";
    $dbr = sql_query($sql);
    while (list($pmsg_id, $pmsg_from, $pmsg_subject, $pmsg_date) = sql_fetch_row($dbr))
        echo "<tr><td><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;uname=$pmsg_from\">$pmsg_from</td>\n"
            . "<td>$pmsg_subject</td>\n"
            . "<td>$pmsg_date</td>\n"
            . "<td><a href=\"modules.php?name=$module_name&amp;action=ReadPMSG&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"$image_file1\" border=\"0\" alt=\"" . _PMSGSREADING . "\"></a>&nbsp;"
            . "<a href=\"modules.php?name=$module_name&amp;action=DelPMSGReceive&amp;pmsg_id=$pmsg_id&amp;cfp=ShowPMSGsNew\">"
            . "<img src=\"$image_file2\" border=\"0\" alt=\""._PMSGSDELETING."\"></a></td></tr>";
    echo "</table>";
    CloseTable();
    echo "<br>\n";

    ShowPmsgsFooter();
}

/**
 * ShowPMSGsRead
 *
 * Zeigt bereits gelesene Messages an (Archiv)
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function ShowPMSGsRead()
{
    global $module_name, $bgcolor3;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();
    $sql    = "SELECT `pmsg_id`,
                      `pmsg_from`,
                      `pmsg_subject`,
                      `pmsg_date`,
                      `pmsg_answer`,
                      `pmsg_del_from`
               FROM `" . $config->prefix . "_pmsg`
               WHERE `pmsg_to`='" . vkpVarPrepForStore($user->GetUname()) . "'
                     AND `pmsg_read`='1'
                     AND `pmsg_del_to`='0'
               ORDER BY `pmsg_id` DESC";

    ShowPmsgsHeader(_PMSGSPAGETITLEARCHIVE);
    OpenTable();
    echo "<a href=\"modules.php?name=$module_name\">[ " . _PMSGSNEWMESSAGES . " ]</a></td>\n"
        . "<td align=\"center\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsRead\"><b>[ "._PMSGSARCHIV." ]</b></a></td>\n"
        . "<td align=\"right\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsSend\">[ " . _PMSGSOUTGOINGPOST . " ]</a>";
    CloseTable();
    echo "<br>\n";

    OpenTable();
    echo "<table width=\"100%\" cellpadding=\"2\" cellspacing=\"0\" border=\"0\">"
        . "<tr bgcolor=\"$bgcolor3\">\n"
        . "<td><b>" . _PMSGSSENDER . "</b></td>"
        . "<td><b>" . _PMSGSSUBJECT . "</b></td>"
        . "<td><b>" . _PMSGSDATETIME . "</b></td>\n"
        . "<td><b>" . _PMSGSACTION . "/" . _PMSGSSTATUS . "</b></td></tr>\n";
    $dbr = sql_query($sql);
    while (list($pmsg_id,
                $pmsg_from,
                $pmsg_subject,
                $pmsg_date,
                $pmsg_answer,
                $pmsg_del_from) = sql_fetch_row($dbr))
    {
        echo "<tr><td><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;uname=$pmsg_from\">$pmsg_from</td>\n"#
            . "<td>$pmsg_subject</td>\n"
            . "<td>$pmsg_date</td>"
            . "<td><a href=\"modules.php?name=$module_name&amp;action=ReadPMSG&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"modules/" . vkpVarPrepForOs($module_name) . "/images/new.gif\" border=\"0\" alt=\""._PMSGSREADING."\"></a>&nbsp;"
            . "<a href=\"modules.php?name=$module_name&amp;action=DelPMSGReceive&amp;pmsg_id=$pmsg_id&amp;cfp=ShowPMSGsRead\">"
            . "<img src=\"modules/" . vkpVarPrepForOs($module_name) . "/images/loeschen.gif\" border=\"0\" alt=\""._PMSGSDELETING."\"></a>";
        if ($pmsg_answer == 1)
            echo "&nbsp;<img src=\"modules/" . vkpVarPrepForOs($module_name) . "/images/antwort.gif\" border=\"0\" alt=\""._PMSGSANSWERED."\">";
        if ($pmsg_del_from == 1)
            echo "&nbsp;<img src=\"modules/" . vkpVarPrepForOs($module_name) . "/images/geloscht.gif\" border=\"0\" alt=\""._PMSGSSENDERDELETED."\">";
        echo "</td></tr>";
    } // while
    echo "</table>";
    CloseTable();
    echo "<br>\n";
    ShowPmsgsFooter();
}


/**
 * ShowPMSGsSend
 *
 * Zeigt gesendete Messages an
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function ShowPMSGsSend()
{
    global $module_name, $bgcolor3;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();
    $sql    = "SELECT `pmsg_id`,
                      `pmsg_to`,
                      `pmsg_subject`,
                      `pmsg_date`,
                      `pmsg_answer`,
                      `pmsg_del_to`,
                      `pmsg_read`
               FROM `" . $config->prefix."_pmsg`
               WHERE `pmsg_from`='" . vkpVarPrepForStore($user->GetUname()) . "'
                     AND `pmsg_del_from`='0'
               ORDER BY `pmsg_id` DESC";

    ShowPmsgsHeader(_PMSGSPAGETITLESENT);

    // Navigation
    //
    OpenTable();
    echo "<a href=\"modules.php?name=$module_name\">[ "._PMSGSNEWMESSAGES." ]</a></td>\n"
        . "<td align=\"center\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsRead\">[ "._PMSGSARCHIV." ]</a></td>\n"
        . "<td align=\"right\"><a href=\"modules.php?name=$module_name&action=ShowPMSGsSend\"><b>[ "._PMSGSOUTGOINGPOST." ]</b></a>";
    CloseTable();
    echo "<br>\n";

    OpenTable();
    echo "<table width=\"100%\" cellpadding=\"2\" cellspacing=\"0\" border=\"0\">";
    echo "<tr bgcolor=\"$bgcolor3\">\n"
        . "<td><b>"._PMSGSRECEIVER."</b></td>\n"
        . "<td><b>"._PMSGSSUBJECT."</b></td>\n"
        . "<td><b>"._PMSGSDATETIME."</b></td>\n"
        . "<td><b>"._PMSGSACTION."/"._PMSGSSTATUS."</b></td></tr>\n";
    $dbr = sql_query($sql);
    while (list($pmsg_id,
                $pmsg_to,
                $pmsg_subject,
                $pmsg_date,
                $pmsg_answer,
                $pmsg_del_to,
                $pmsg_read) = sql_fetch_row($dbr))
    {
        echo "<tr><td><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;uname=$pmsg_to\">$pmsg_to</td>\n"
            . "<td>$pmsg_subject</td>\n"
            . "<td>$pmsg_date</td>\n"
            . "<td><a href=\"modules.php?name=$module_name&amp;action=ReadPMSG&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/new.gif\" border=\"0\" alt=\""._PMSGSREADING."\"></a>&nbsp;"
            . "<a href=\"modules.php?name=$module_name&amp;action=DelPMSGSend&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/loeschen.gif\" border=\"0\" alt=\""._PMSGSDELETING."\"></a>";
        if ($pmsg_read == 1)
            echo "&nbsp;<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/gelesen.gif\" border=\"0\" alt=\""._PMSGSRECEIVERREADED."\">";
        if ($pmsg_answer == 1)
            echo "&nbsp;<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/antwort.gif\" border=\"0\" alt=\""._PMSGSRECEIVERANSWERED."\">";
        if ($pmsg_del_to == 1)
            echo "&nbsp;<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/geloscht.gif\" border=\"0\" alt=\""._PMSGSRECEIVERDELETED."\">";
        echo "</td></tr>\n";
    }
    echo "</table>";
    CloseTable();
    echo "<br>";
    ShowPmsgsFooter();
}

/**
 * ReadPMSG
 *
 * Zeigt eine Message mit der $pmsg_id an
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function ReadPMSG($pmsg_id)
{
    global $module_name, $bgcolor3, $bgcolor4;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();

    $result2 = sql_query("SELECT `pmsg_id`,
                                 `pmsg_from`,
                                 `pmsg_to`,
                                 `pmsg_subject`,
                                 `pmsg_date`,
                                 `pmsg_text`,
                                 `pmsg_read`
                          FROM `" . $config->prefix . "_pmsg`
                          WHERE `pmsg_id`='" . vkpVarPrepForStore((int) $pmsg_id) . "'
                                AND (`pmsg_to`='" . vkpVarPrepForStore($user->GetUname()) . "'
                                OR `pmsg_from`='" . vkpVarPrepForStore($user->GetUname()) . "')");

    list ($pmsg_id,
          $pmsg_from,
          $pmsg_to,
          $pmsg_subject,
          $pmsg_date,
          $pmsg_text,
          $pmsg_read) = sql_fetch_row($result2);

    // Kein Datensatz gefunden
    //
    if (empty($pmsg_id))
        vkpLocation("modules.php?name=$module_name");

    $pmsg_text=stripslashes($pmsg_text);

    ShowPmsgsHeader(_PMSGSPAGETITLEREAD);

    OpenTable();
    echo "<a href=\"modules.php?name=$module_name\">[ "._PMSGSNEWMESSAGES." ]</a></td>\n"
        . "<td align=\"center\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsRead\">[ "._PMSGSARCHIV." ]</a></td>\n"
        . "<td align=\"right\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsSend\">[ "._PMSGSOUTGOINGPOST." ]</a>";
    CloseTable();
    echo "<br>\n";

    OpenTable();
    echo "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"2\" border=\"0\">"
        . "<tr bgcolor=\"$bgcolor3\" valign=\"top\">\n"
        . "<td width=\"200\"><b>"._PMSGSSENDERSINFO.":</b><hr noshade>"
        . "<br><br>\n"
        . "<a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;uname=$pmsg_from\">$pmsg_from</a></td>\n"
        . "<td bgcolor=\"$bgcolor4\"><b>"._PMSGSMESSAGEFROMDATE." $pmsg_date</b><hr noshade>$pmsg_text</td></tr>\n"
        . "<tr bgcolor=\"$bgcolor4\"><td colspan=\"2\"><hr noshade>&nbsp;"
        . "<a href=\"modules.php?name=$module_name&action=PrintPMSG&amp;pmsg_id=$pmsg_id\">"
        . "<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/printer.gif\" border=\"0\" alt=\""._PMSGSPRINTVIEW."\"></a>";

    if (strcasecmp($pmsg_to, $user->GetUname) == 0)
    {
        echo "&nbsp;<a href=\"modules.php?name=$module_name&amp;action=WritePMSG&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/reply.gif\" border=\"0\" alt=\""._PMSGSREPLY."\">"
            . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;action=DelPMSGReceive&amp;pmsg_id=$pmsg_id\">"
            . "<img src=\"modules/".vkpVarPrepForOs($module_name)."/images/loeschen.gif\" border=\"0\" alt=\""._PMSGSDELETING."\">"
            . "</a></td></tr>\n";

        // Als gelesen markieren, wenn der aktuelle benutzer auch der Empfnger ist.
        //
        if ($pmsg_read=='0')
            sql_query("UPDATE `".$config->prefix."_pmsg`
                       SET `pmsg_read`='1'
                       WHERE `pmsg_id`='" . vkpVarPrepForStore($pmsg_id) . "'");
    }
    echo "</table>";

    CloseTable();
    echo "<br>\n";
    ShowPmsgsFooter();
}

/**
 * WritePMSG
 *
 * Funktion zum schreiben einer neuen Message
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function WritePMSG()
{
    global $module_name, $bgcolor3, $bgcolor4;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();

    list($replyid,
         $touser) = vkpVarCleanFromInput('pmsg_id',
                                         'uname');

    if(!empty($replyid))
    {
        $result2 = sql_query("SELECT `pmsg_to`,
                                     `pmsg_from`,
                                     `pmsg_subject`
                              FROM `" . $config->prefix . "_pmsg`
                              WHERE `pmsg_id`='" . vkpVarPrepForStore($replyid) . "'");
        $row2 = sql_fetch_array($result2);

        if (($row !== false) && ( strcasecmp($user->GetUname(), $row2['pmsg_to']) == 0))
        {
            $pmsg_to        = $row2['pmsg_from'];
            $pmsg_subject   = "Re: $row2[pmsg_subject]";
        }
        else
        {
            $pmsg_to        = '';
            $pmsg_subject   = '';
        }
    }
    elseif (!empty($touser))
    {
        $pmsg_to        = $touser;
        $pmsg_subject   = '';
    }
    else
    {
        $pmsg_to        = '';
        $pmsg_subject   = '';
    }

    ShowPmsgsHeader(_PMSGSPAGETITLEWRITE);

    OpenTable();
    echo "<a href=\"modules.php?name=$module_name\">[ "._PMSGSNEWMESSAGES." ]</a></td>\n"
        . "<td align=\"center\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsRead\">[ "._PMSGSARCHIV." ]</a></td>\n"
        . "<td align=\"right\"><a href=\"modules.php?name=$module_name&amp;action=ShowPMSGsSend\">[ "._PMSGSOUTGOINGPOST." ]</a>";
    CloseTable();
    echo "<br>\n";

    OpenTable();
?>
    <script language="JavaScript"><!--
    /**
     * PMSGPruefung
     *
     * Kleine Javascriptroutine zur sofortigen Prfung ob alle Felder der enuen Message augefllt sind
     *
     * @version 0.1
     * @since 5.5.1
     * @author Andreas Kunz
     */
    function PMSGPruefung()
    {
        if(document.Formular.pmsg_to.value=="")
        {
            alert("<?php echo ""._PMSGSINSERTRECEIVER.""; ?>");
            document.Formular.pmsg_to.focus();
            return false;
        }
        if(document.Formular.pmsg_subject.value=="")
        {
            alert("<?php echo ""._PMSGSINSERTSUBJECT.""; ?>");
            document.Formular.pmsg_subject.focus();
            return false;
        }
        if(document.Formular.pmsg_text.value=="")
        {
            alert("<?php echo ""._PMSGSINSERTMESSAGE.""; ?>");
            document.Formular.pmsg_text.focus();
            return false;
        }
    }
    // --></script>
<?php
    echo "<form name=\"Formular\" action=\"modules.php\" method=\"post\" onSubmit=\"return PMSGPruefung()\">\n"
        . "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"2\" border=\"0\">\n"
        . "<input type=\"hidden\" name=\"name\" value=\"$module_name\">\n"
        . "<input type=\"hidden\" name=\"action\" value=\"SavePMSG\">\n"
        . "<input type=\"hidden\" name=\"pmsg_id\" value=\"$replyid\">\n"
        . "<input type=\"hidden\" name=\"pmsg_from\" value=\"" . $user->GetUname() . "\">\n"
        . "<tr>\n"
        . "<td width=\"50\" bgcolor=\"$bgcolor3\" ><b>"._PMSGSRECEIVER.":</b></td>\n"
        . "<td bgcolor=\"$bgcolor4\"><input type=\"text\" name=\"pmsg_to\" size=\"50\" maxlength=\"50\" value=\"$pmsg_to\"></td>\n"
        . "</tr>\n"
        . "<tr>\n"
        . "<td bgcolor=\"$bgcolor3\" ><b>"._PMSGSSUBJECT.":</b></td>\n"
        . "<td bgcolor=\"$bgcolor4\"><input type=\"text\" name=\"pmsg_subject\" size=\"50\" maxlength=\"100\" value=\"$pmsg_subject\"></td>\n"
        . "</tr>\n"
        . "<tr bgcolor=\"$bgcolor3\" valign=\"top\">\n"
        . "<td><b>"._PMSGSMESSAGETEXT.":</b></td>\n"
        . "<td bgcolor=\"$bgcolor4\"><textarea wrap=\"virtual\" cols=\"60\" rows=\"5\" name=\"pmsg_text\"></textarea></td>\n"
        . "</tr>\n"
        . "<tr>\n"
        . "<td>&nbsp;</td>\n"
        . "<td><input type=\"submit\" value=\""._PMSGSSUBMIT."\"></td>\n"
        . "</tr>\n"
        . "</table>\n"
        . "</form>";
    CloseTable();
    ShowPmsgsFooter();
}

/**
 * clickable
 *
 * Funktion zum Erstellen von anklickbaren Links bei Mailadressen und Webadressen
 *
 * @version 0.1
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 * @todo In den Kern verlagern
 */
function clickable($pmsg_text)
{
    $pmsg_text = eregi_replace(" ([[:alnum:]]+)://([^[:space:]]*)([[:alnum:]#?/&=])", " <a href=\"\\1://\\2\\3\" target=\"_blank\" target=\"_new\">\\1://\\2\\3</a>", $pmsg_text);
    $pmsg_text = eregi_replace(" (([a-z0-9_]|\\-|\\.)+@([^[:space:]]*)([[:alnum:]-]))", " <a href=\"mailto:\\1\" target=\"_new\">\\1</a>", $pmsg_text);
    return $pmsg_text;
}

/**
 * PrintPMSG
 *
 * Druckansicht der Message
 *
 * @version 0.2
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function PrintPMSG($pmsg_id)
{
    global $module_name, $bgcolor3, $bgcolor4;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();

    $result2 = sql_query("SELECT `pmsg_id`,
                                 `pmsg_from`,
                                 `pmsg_to`,
                                 `pmsg_subject`,
                                 `pmsg_date`,
                                 `pmsg_text`,
                                 `pmsg_read`
                          FROM `" . $config->prefix . "_pmsg`
                          WHERE `pmsg_id`='" . vkpVarPrepForStore((int) $pmsg_id) . "' AND (`pmsg_to`='" . vkpVarPrepForStore($user->GetUname()) . "' OR `pmsg_from`='" . vkpVarPrepForStore($user->GetUname()) . "')");
    list ($pmsg_id,
          $pmsg_from,
          $pmsg_to,
          $pmsg_subject,
          $pmsg_date,
          $pmsg_text,
          $pmsg_read) = sql_fetch_row($result2);

    if (empty($pmsg_id))
        vkpLocation("modules.php?name=$module_name");

    $pmsg_text = stripslashes($pmsg_text);
    echo "<html><head><title>$pmsg_subject</title></head><body>\n"
        . "<table width=\"650\" cellpadding=\"5\" cellspacing=\"2\" border=\"0\"> "
        . "<tr valign=\"top\"><td width=\"200\"><b>"._PMSGSSENDERSINFO.":</b><hr noshade>"
        . "$pmsg_from</td><td><b>"._PMSGSMESSAGEFROMDATE." $pmsg_date</b><hr noshade>$pmsg_text</td></tr>\n"
        . "<tr><td colspan=\"2\"><hr noshade>"
        . "</table>"
        . "<br>"
        . "<script language=\"JavaScript\">\n"
        . "alert ('"._PMSGSPRINTINFO."')\n"
        . "</script></body></html>\n";
}

/**
 * DelPMSGReceive
 *
 * Lschen einer empfangenen Message
 *
 * @param int $pmsg_id Die ID der Nachricht
 * @version 0.1
 * @since 5.5.1
 * @author Hinrich Donner
 * @author Andreas Kunz
 */
function DelPMSGReceive($pmsg_id)
{
    global $module_name;

    $config =& vkpConfig::GetInstance();
    $user   =& vkpUser::GetInstance();

    $result2 = sql_query("SELECT `pmsg_to`
                          FROM `".$config->prefix."_pmsg`
                          WHERE `pmsg_id`='" . vkpVarPrepForStore($pmsg_id) . "'");
    if (false === ($row2 = sql_fetch_array($result2)))
        return;

    if (strcasecmp($row2['pmsg_to'], $user->GetUname()) == 0)
        sql_query("UPDATE `" . $config->prefix . "_pmsg`
                   SET `pmsg_del_to`='1'
                   WHERE `pmsg_id`='" . vkpVarPrepForStore((int) $pmsg_id) . "'");
}

/**
 * Zugangsberechtigung prfen
 *
 * @ignore
 */
$user   =& vkpUser::GetInstance();
if (!$user->logged_in)
    vkpLocation('modules.php?name=Your_Account');

/**
 * Befehl auswerten
 *
 * @ignore
 */
$action = vkpVarCleanFromInput('action');
switch($action)
{

    // Archive
    //
    case "ShowPMSGsRead":
        ShowPMSGsRead();
        break;

    // Versandte
    //
    case "ShowPMSGsSend":
        ShowPMSGsSend();
        break;

    // Lschen einer Nachricht
    //
    case "DelPMSGReceive":
        $pmsg_id = vkpVarCleanFromInput('pmsg_id');
        DelPMSGReceive($pmsg_id);
        vkpLocation("modules.php?name=$module_name");
        break;

/**
 * DelPMSGSend
 *
 * Lschen einer gesendeten Message
 *
 * @author Andreas Kunz
 */
    case "DelPMSGSend":
    global $user_prefix, $dbi, $user, $module_name, $cookie, $prefix, $nukeurl;
    cookiedecode($user);
    $uname = $cookie[1];
    $pass = $cookie[2];
    $result1 = sql_query("SELECT uname from ".$user_prefix."_users WHERE uname='$uname' AND pass='$pass'", $dbi);
    $row1 = sql_fetch_array($result1, $dbi);
    $uname=$row1[uname];
    $pmsg_id = $_GET[pmsg_id];
    $result2 = sql_query("SELECT pmsg_from FROM ".$prefix."_pmsg WHERE pmsg_id='$pmsg_id'", $dbi);
    $row2 = sql_fetch_array($result2, $dbi);
    if($uname=="$row2[pmsg_from]"){
        sql_query("UPDATE ".$prefix."_pmsg SET pmsg_del_from='1' WHERE pmsg_id='$pmsg_id'", $dbi);
        header("location: modules.php?name=".$module_name."&action=ShowPMSGsSend");
    } else {
        echo "<html>\n";
            echo "<title>"._PMSGSHACKERALARM."</title>\n";
            echo "<body bgcolor=\"#FFFFFF\" text=\"#000000\">\n\n<br><br><br>\n\n";
            echo "<center><img src=\"images/eyes.gif\" border=\"0\"><br><br>\n";
            echo "<font face=\"Verdana\" size=\"+4\"><b>"._PMSGSNICETRY."! :-)</b></font></center>\n";
            echo "</body>\n";
            echo "</html>\n";
            exit;
    }

    break;

    case "WritePMSG":
    WritePMSG($pmsg_id);
    break;

    case "ReadPMSG":
    ReadPMSG($pmsg_id);
    break;

    case "PrintPMSG":
    PrintPMSG($pmsg_id);
    break;

/**
 * SavePMSG
 *
 * Speichern einer neuen Message
 *
 * @author Andreas Kunz
 */
    case "SavePMSG":
    global $dbi, $module_name, $prefix, $nukeurl;
    include('functions.php');
    $pmsg_id = $_POST[pmsg_id];
    $pmsg_from = $_POST[pmsg_from];
    $pmsg_to = $_POST[pmsg_to];
    $pmsg_subject = $_POST[pmsg_subject];
    $pmsg_text = $_POST[pmsg_text];
    $pmsg_text = nl2br($pmsg_text);
    $pmsg_text = clickable($pmsg_text);
    $pmsg_text = addslashes($pmsg_text);
    $time = date("Y-m-d H:i");
    sql_query("insert into ".$prefix."_pmsg values (NULL, '$pmsg_to', '$pmsg_from', '$pmsg_subject', '$time', '0', '0', '0', '0', '0', '$pmsg_text' )", $dbi);
    if($pmsg_id!=""){
        sql_query("UPDATE ".$prefix."_pmsg SET pmsg_answer='1' WHERE pmsg_id='$pmsg_id'", $dbi);
    }
    header("location: modules.php?name=".$module_name."");
    break;

    default:
    ShowPMSGsNew();
    break;

}

?>
